'THIS QUICKBASIC PROGRAM FINDS THE DAY OF THE WEEK FOR ANY DATE FROM 1/1/1583
'TO THE PRESENT. IT STARTS IN 1583 BECAUSE THE CALENDAR WAS CHANGED BY
'POPE GREGORY (OF MEDIEVAL LITURGICAL MUSIC FAME) IN LATE 1582; SO DATES
'BEFORE OCT. 15 1582 REQUIRE A DIFFERENT ALGORITHM.

'THIS PROGRAM CAN BE USED AS A STANDALONE OR AS A SUBROUTINE.  THE INPUT IS
'MONTH, DAY YEAR (EG. 12,7,1941) AND THE OUTPUT IS A STRING, THE DAY OF WEEK.

'FEEL FREE TO USE IT AS YOU PLEASE; COMMENTS WILL BE APPRECIATED.
'
'DR. WARD DEUTSCHMAN
'BRIARCLIFFE COLLEGE
'WOODBURY, NY 11568
'

DIM WEEKDAY$(7)
DATA "SUNDAY", "MONDAY","TUESDAY","WEDNESDAY","THURSDAY","FRIDAY", "SATURDAY"
FOR I = 1 TO 7: READ WEEKDAY$(I): NEXT I

START:
INPUT "ENTER DATE AS 3,4,1993 (OR 0,0,0 TO EXIT)", M%, D%, Y%
     IF Y% = 0 THEN GOTO BAIL
     IF Y% < 100 THEN Y% = Y% + 1900    '*** CORRECT FOR 2-DIGIT ENTRY!
     IF Y% < 1583 THEN
          CLS
          PRINT "CALENDAR CHANGED IN 1582. PLEASE USE LATER DATE."
          PRINT
          GOTO START
     END IF
     IF M% < 1 THEN GOTO ERCHK
     IF M% > 12 THEN GOTO ERCHK
     IF D% < 1 THEN GOTO ERCHK
     IF D% > 31 THEN GOTO ERCHK

GOTO MOVEON

ERCHK:
          CLS
          PRINT "ERROR IN YOUR ENTRY. PLEASE TRY AGAIN"
          PRINT
          GOTO START

MOVEON:
        
        M% = M% - 2                     ' *** SINCE CAL. CHANGED IN MARCH
          IF M% < 1 THEN                '     OF 1582, THAT IS MONTH #1,
                M% = M% + 12            '     APRIL IS 2, ETC.
                Y% = Y% - 1
          END IF
        CENT = INT(Y% / 100)            ' *** GET THE CENTURY PART OF YEAR
        Y% = Y% MOD 100                 ' *** NOW GET THE YEAR PART

        TEMP = INT(2.6 * M% - .19) + D% + Y% + INT(Y% / 4)
        DAYNUM = (TEMP + (INT(CENT / 4)) - 2 * CENT) MOD 7
        IF DAYNUM < 0 THEN DAYNUM = DAYNUM + 7

PRINT WEEKDAY$(DAYNUM + 1)

GOTO START
BAIL:
     END

